from django.db import migrations, models

import arkindex.process.models


class Migration(migrations.Migration):

    dependencies = [
        ("process", "0030_remove_repository_processes"),
    ]

    operations = [
        migrations.AddConstraint(
            model_name="process",
            constraint=models.CheckConstraint(check=models.Q(("mode", arkindex.process.models.ProcessMode["Local"]), models.Q(("corpus", None), _negated=True), _connector="XOR"), name="check_process_corpus", violation_error_message="Local processes cannot have a corpus, and other modes must have one set."),
        ),
        migrations.RemoveField(
            model_name="process",
            name="revision",
        ),
    ]
