SAVEPOINT "{savepoint}";

SELECT COUNT(*) FILTER (
                        WHERE path[array_length(path, 1)] = '{A}'::uuid),
                COUNT(*) FILTER (
                                 WHERE path[array_length(path, 1)] <> '{A}'::uuid),
    (SELECT path
     FROM documents_elementpath
     WHERE element_id = '{B}'::uuid
         AND path[array_length(path, 1)] = '{A}'::uuid
     LIMIT 1)
FROM documents_elementpath
WHERE element_id = '{B}'::uuid ;

UPDATE documents_elementpath
SET path = path[3:]
WHERE path @> '{{{first_parent},{A},{B}}}'::uuid[]
    AND path[0:3] = '{{{first_parent},{A},{B}}}'::uuid[] ;

UPDATE "documents_elementpath"
SET "path" = '{{}}'::uuid[]
WHERE ("documents_elementpath"."element_id" = '{B}'::uuid
       AND "documents_elementpath"."path" = (ARRAY['{first_parent}'::uuid,
                                                   '{A}'::uuid])::uuid[]);

DELETE
FROM documents_elementpath child_paths USING documents_elementpath old_parent_paths
WHERE old_parent_paths.element_id = '{B}'::uuid
    AND old_parent_paths.path[array_length(old_parent_paths.path, 1)] = '{A}'::uuid
    AND child_paths.path @> (old_parent_paths.path || '{B}'::uuid) ;

DELETE
FROM "documents_elementpath"
WHERE ("documents_elementpath"."element_id" = '{B}'::uuid
       AND "documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{A}'::uuid);

RELEASE SAVEPOINT "{savepoint}"
